// EdgeCompress.cpp: CEdgeCompress NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "EdgeCompress.h"

#define FREE(i) do { if (i) { delete i; i = NULL; }} while(0)

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CEdgeCompress::CEdgeCompress()
{
	dat_top = dat_bot = NULL;
	m_nCount = 0;
}

CEdgeCompress::~CEdgeCompress()
{
	AllDelete();
}

void CEdgeCompress::AllDelete()
{
	EDGE_COMPLIST* tmp = dat_top,*next;
	while (tmp) {
		next = tmp->next;
		FREE(tmp);
		tmp=next;
	}
	dat_top = dat_bot = NULL;
	m_nCount = 0;
}

void CEdgeCompress::Add(DWORD position, DWORD length, BYTE value)
{
	EDGE_COMPLIST* tmp = new EDGE_COMPLIST;
	tmp->length = length;
	tmp->position = position;
	tmp->value = value;
	tmp->next = NULL;

	if (dat_bot == NULL) {
		dat_top = dat_bot = tmp;
	}
	else {
		dat_bot->next = tmp;
		dat_bot = tmp;
	}
	m_nCount++;
}

// kăt@C֏
bool CEdgeCompress::Write(FILE *fp, const BYTE *DataSrc, int size)
{
	BYTE* DataDest = new BYTE[size];
	int src = 0, dest = 0, i, j;

	AllDelete();
	while (src < size) {
		for (i = src + 1, j = 0; i < size; i++, j++) {
			if (DataSrc[i] != DataSrc[src]) {
				break;
			}
		}

		if (j > 9) {
			Add(dest, j+1, DataSrc[src]);
			src += j + 1;
		}
		else {
			DataDest[dest] = DataSrc[src];
			src++;
			dest++;
		}
	}

	fwrite(&m_nCount, sizeof(int), 1, fp);
	EDGE_COMPLIST* tmp = dat_top;
	
	while (tmp) {
		if (fwrite(&tmp->position, sizeof(DWORD), 1, fp) != 1) {
			return false;
		}
		if (fwrite(&tmp->length, sizeof(DWORD), 1, fp) != 1) {
			return false;
		}
		if (fwrite(&tmp->value, 1, 1, fp) != 1) {
			return false;
		}
		tmp = tmp->next;
	}
	if (fwrite(&dest, sizeof(int), 1, fp) != 1) {
		return false;
	}

	if (fwrite(DataDest, 1, dest, fp) != (unsigned)dest) {
		return false;
	}

	FREE(DataDest);

	return true;
}

bool CEdgeCompress::Read(FILE* fp, BYTE* DataDest, DWORD dest_max)
{
	DWORD comp_max;
	if (fread(&comp_max, sizeof(int), 1, fp) != 1) {
		return false;
	}

	DWORD* position = new DWORD[comp_max];
	DWORD* length = new DWORD[comp_max];
	BYTE* value= new BYTE[comp_max];
	
	UINT i,j;
	for (i = 0; i < comp_max; i++) {
		if (fread(&position[i], sizeof(DWORD), 1, fp) != 1) {
			return false;
		}
		if (fread(&length[i], sizeof(DWORD), 1, fp) != 1) {
			return false;
		}
		if (fread(&value[i], 1, 1, fp) != 1) {
			return false;
		}
	}
	
	DWORD src_max;
	fread(&src_max, sizeof(int), 1, fp);
	BYTE *DataSrc = new BYTE[src_max];
	fread(DataSrc, 1, src_max, fp);

	DWORD comp=0, dest=0;
	for (i = 0; i <= src_max; i++) {
		if (comp < comp_max && i == position[comp]) {
			for (j = 0; j < length[comp]; j++) {
				if (dest + j < dest_max) {
					DataDest[dest + j] = value[comp];
				}
			}
			dest += length[comp];
			comp++;
			i--;
			continue;
		}
		if (i < src_max) {
			DataDest[dest] = DataSrc[i];
			dest++;
		}
	}

	FREE(position);
	FREE(length);
	FREE(value);
	FREE(DataSrc);

	return true;
}